﻿Imports System.IO
Imports System.Xml

Module Module1

    Dim x() As Single
    Dim y() As Single
    Dim n As Integer
    Dim A As Single

    Sub Main()

        ' Podatki()
        PodatkiIzDatoteke()
        Izracun()
        Izpis()
        IzpisVTxt()
        IzpisVXml()
        IzpisVXml2()

    End Sub

    Sub IzpisVXml2()

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko (XML knjižnica) ...")

        Dim xmlDoc As New XmlDocument

        Dim xmlDec As XmlDeclaration = xmlDoc.CreateXmlDeclaration("1.0", "UTF-8", Nothing)
        xmlDoc.AppendChild(xmlDec)

        Dim xmlPrerez As XmlElement = xmlDoc.CreateElement("prerez")
        xmlDoc.AppendChild(xmlPrerez)

        Dim xmlNaslov As XmlElement = xmlDoc.CreateElement("naslov")
        xmlNaslov.InnerText = "Primer 1"
        xmlPrerez.AppendChild(xmlNaslov)

        Dim xmlTocke As XmlElement = xmlDoc.CreateElement("tocke")
        xmlPrerez.AppendChild(xmlTocke)

        For i As Integer = 1 To n
            Dim xmlTocka As XmlElement = xmlDoc.CreateElement("tocka")
            xmlTocka.SetAttribute("id", i)
            xmlTocke.AppendChild(xmlTocka)

            Dim xmlX As XmlElement = xmlDoc.CreateElement("x")
            xmlX.InnerText = x(i)
            xmlTocka.AppendChild(xmlX)

            Dim xmlY As XmlElement = xmlDoc.CreateElement("y")
            xmlY.InnerText = y(i)
            xmlTocka.AppendChild(xmlY)
        Next

        xmlDoc.Save("primer2.xml")

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko zaključen.")

    End Sub

    Sub IzpisVXml()
        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko ...")

        Dim dat As StreamWriter
        dat = New StreamWriter("primer.xml")

        dat.WriteLine("<prerez>")
        dat.WriteLine("<naslov>" & "Primer 1" & "</naslov>")
        dat.WriteLine("<tocke>")
        For i As Integer = 1 To n
            dat.WriteLine("<tocka id=""{0}"">", i)
            dat.WriteLine("<x>{0}</x>", x(i))
            dat.WriteLine("<y>{0}</y>", y(i))
            dat.WriteLine("</tocka>")
        Next
        dat.WriteLine("</tocke>")
        dat.WriteLine("</prerez>")

        dat.Close()

        Console.WriteLine()
        Console.WriteLine("--- Izpis v XML datoteko zaključen.")

    End Sub

    Sub IzpisVTxt()
        Console.WriteLine()
        Console.WriteLine("--- Izpis v TXT datoteko ...")

        Dim dat As StreamWriter
        dat = New StreamWriter("primer-rez.txt")

        dat.WriteLine("--- Podatki")
        dat.WriteLine("Št. točk = " & n)
        dat.WriteLine("Točke ...")
        For i As Integer = 1 To n
            dat.WriteLine("T({0}): x = {1}, y = {2}", i, x(i), y(i))
        Next
        dat.WriteLine()
        dat.WriteLine("--- Rezultati")
        dat.WriteLine("A = " & A)

        dat.Close()

        Console.WriteLine()
        Console.WriteLine("--- Izpis v TXT datoteko zaključen.")
    End Sub

    Sub PodatkiIzDatoteke()
        Dim dat As StreamReader
        dat = New StreamReader("primer.txt")

        n = dat.ReadLine()
        ReDim x(n + 1)
        ReDim y(n + 1)

        For i As Integer = 1 To n
            Dim vrstica As String = dat.ReadLine()
            Dim besede() As String = vrstica.Split()

            x(i) = besede(0)
            y(i) = besede(1)
        Next
        x(n + 1) = x(1)
        y(n + 1) = y(1)
    End Sub

    Sub Podatki()
        Console.Write("Podaj število točk: ")
        n = Console.ReadLine()
        ReDim x(n + 1)
        ReDim y(n + 1)

        For i As Integer = 1 To n
            Console.Write("Točka {0} (x y): ", i)
            Dim vrstica As String = Console.ReadLine()
            Dim besede() As String = vrstica.Split()

            x(i) = besede(0)
            y(i) = besede(1)
        Next
        x(n + 1) = x(1)
        y(n + 1) = y(1)
    End Sub

    Sub Izracun()
        A = 0
        For i As Integer = 1 To n
            A = A + (x(i + 1) + x(i)) * (y(i + 1) - y(i))
        Next
        A = 0.5 * A
    End Sub

    Sub Izpis()
        Console.WriteLine("--- Podatki")
        Console.WriteLine("Št. točk = " & n)
        Console.WriteLine("Točke ...")
        For i As Integer = 1 To n
            Console.WriteLine("T({0}): x = {1}, y = {2}", i, x(i), y(i))
        Next
        Console.WriteLine()

        Console.WriteLine("--- Rezultati")
        Console.WriteLine("A = " & A)
    End Sub

End Module
